#ifndef INPUT_MODPLAY_H
#define INPUT_MODPLAY_H

#include "stdafx.h"
#include "..\libmodplay\modplay.h"

// Note that input class does *not* implement virtual methods or derive from interface classes.
// Our methods get called over input framework templates. See input_singletrack_impl for descriptions of what each method does.
// input_stubs just provides stub implementations of mundane methods that are irrelevant for most implementations.
class input_modplay: public input_stubs
{
public:
   void open( service_ptr_t<file> p_filehint, const char *p_path, t_input_open_reason p_reason, abort_callback &p_abort );
   void get_info( file_info &p_info, abort_callback &p_abort );
   t_filestats get_file_stats( abort_callback &p_abort );
   void decode_initialize( unsigned p_flags, abort_callback &p_abort );
   bool decode_run( audio_chunk &p_chunk, abort_callback &p_abort );
   void decode_seek( double p_seconds, abort_callback &p_abort );
   bool decode_can_seek();
   bool decode_get_dynamic_info( file_info &p_out, double &p_timestamp_delta );
   bool decode_get_dynamic_info_track( file_info &p_out, double &p_timestamp_delta );
   void decode_on_idle( abort_callback &p_abort );
   void retag( const file_info &p_info, abort_callback &p_abort );
   static bool g_is_our_content_type( const char *p_content_type );
   static bool g_is_our_path( const char *p_path, const char *p_extension );
   static const char *g_get_name();
   static const GUID g_get_guid();

private:
   pfc::array_t<t_uint8> m_buffer;
   MODFILE m_mod;
   t_filestats m_filestats;
};

#endif
